package net.chat;

import futils.Futil;
import futils.ReaderUtil;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;

/**
 * Copyright DocJava, inc.
 * User: lyon
 * Date: Oct 27, 2004
 * Time: 4:59:20 AM
 */
public class Mchat {
    public static void main(String[] args) throws IOException {
        String strin;
        int port;
        port = 1234;
        InetAddress inetAddress = InetAddress.getByName("224.111.112.113");
        if (!inetAddress.isMulticastAddress()) {
            System.out.println("The address: " +
                    inetAddress +
                    " is not multicast address");
            System.exit(0);
        }
        try {
            MulticastSocket mcastSocket = new MulticastSocket(port);
            mcastSocket.setReuseAddress(false);
            System.out.println("ReuseAddress is: " +
                    mcastSocket.getReuseAddress());
            mcastSocket.setLoopbackMode(true);
            System.out.println("LoopbackMode is: " +
                    mcastSocket.getLoopbackMode());
            mcastSocket.setTimeToLive(2);
            System.out.println("TimeToLive is: " + mcastSocket.getTimeToLive());

            // This enables me to see stuff in the group....
            mcastSocket.joinGroup(inetAddress);
            System.out.println("Joined Group: " +
                    inetAddress +
                    " Port:" +
                    port);

            // ChatThread will handle the incoming
            // Data and print it out to STDN output.
            new ChatThread(mcastSocket);

            // Now read from STDN input and send the Data to the Group.

            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
            System.out.println("Type anything followed by RETURN," +
                    " or Ctrl+D to  terminate the program.");
            for (; ;) {
                //Read from the STDN input
                strin = br.readLine();
                if (strin.startsWith("open:")) {
                    sendAFile(inetAddress,
                            port,
                            mcastSocket);
                    continue;
                }
                if (strin == null) break; // User Hit Ctrl+D
                DatagramPacket dp = new DatagramPacket(strin.getBytes(),
                        strin.length(),
                        inetAddress,
                        port);
                mcastSocket.send(dp);
            }
            System.out.println("Leaving the Group...");
            mcastSocket.leaveGroup(inetAddress);
            mcastSocket.close();
        } catch (Exception err) {
            System.err.println("ERR: Can not join the group " + err);
            err.printStackTrace();
            System.exit(1);
        }
    }

    private static void sendAFile(InetAddress inetAddress,
                                  int port,
                                  MulticastSocket mcastSocket) {
        System.out.println("SendAFile_");
        File f = Futil.getReadFile("select a text file");
        sendAFile(f,
                inetAddress,
                port,
                mcastSocket);
    }

    private static void sendAFile(File f,
                                  InetAddress inetAddress,
                                  int port,
                                  MulticastSocket mcastSocket) {
        try {
            String sa[] = ReaderUtil.getFile(f);
            byte b[] = ReaderUtil.getBytes(sa);
            DatagramPacket dp = new DatagramPacket(b,
                    b.length,
                    inetAddress,
                    port);
            mcastSocket.send(dp);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

